// comcadlg.cpp : implementation file
//

#include "stdafx.h"
#include "comcap.h"
#include "comcadlg.h"


#pragma warning ( disable: 4200 4005 )
extern "C"
{
#include <bh.h>


//#include "const.h"
#include "struct.h"
//#include "data.h"
//#include "help.h"
//#include "objects.h"
//#include "parser.h"
//#include "oldplib.h"
//#include "debug.h"

}


#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


BYTE FrameBuffer[1520];
LPFRAME lpFrame = (LPFRAME)FrameBuffer;

UINT WorkerThread ( LPVOID lpParam );



/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg message handlers

BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	CenterWindow();
	
	// TODO: Add extra about dlg initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

/////////////////////////////////////////////////////////////////////////////
// CComcapDlg dialog

CComcapDlg::CComcapDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CComcapDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CComcapDlg)
	m_InputFilename = _T("");
	m_OutputFilename = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CComcapDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CComcapDlg)
	DDX_Control(pDX, IDC_OUTPUT, m_Output);
	DDX_Control(pDX, IDOK, m_MBOK);
	DDX_Text(pDX, IDC_INPUTFILENAME, m_InputFilename);
	DDX_Text(pDX, IDC_OUTPUTFILENAME, m_OutputFilename);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CComcapDlg, CDialog)
	//{{AFX_MSG_MAP(CComcapDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CComcapDlg message handlers

BOOL CComcapDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	CenterWindow();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}
	
	// TODO: Add extra initialization here

    GetDlgItem ( IDC_INPUTFILENAME)->SetFocus();
	

	return FALSE;  // return TRUE  unless you set the focus to a control
}

void CComcapDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CComcapDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CComcapDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CComcapDlg::OnOK() 
{
	
    UpdateData (TRUE); // get the data from the dialog

    if ( m_InputFilename.IsEmpty() )
    {
        // error and set the focus
        MessageBox ( "You must supply an input file." );
        GetDlgItem ( IDC_INPUTFILENAME)->SetFocus();
        return;
    }

    if ( m_OutputFilename.IsEmpty() )
    {
        // error and set the focus
        MessageBox ( "You must supply a destination capture filename." );
        GetDlgItem ( IDC_OUTPUTFILENAME)->SetFocus();
        return;
    }

    GetDlgItem ( IDC_INPUTFILENAME)->EnableWindow (FALSE);
    GetDlgItem ( IDC_OUTPUTFILENAME)->EnableWindow (FALSE);
    m_MBOK.EnableWindow (FALSE);

    // start a worker thread.  Why?  Because we are currently handling the
    // OnOK message.  If we want test output, we need to not be blocked
    // on the ok message so that our message pump is free.  Note that you
    // must be careful to not have the parent and the child thread doing
    // work on the same data structures.  Also not that if you do a
    // PostMessage from the child thread to the parent and then terminate it,
    // you run the risk that the data you posted is no longer valid when
    // it is received.

    AfxBeginThread ( WorkerThread, (LPVOID) this);

	//CDialog::OnOK();
}


/////////////////////////////////////////////////////////////////////////////
// WorkerThread - Our AFX Thread.
//
// Why have a stub thread?  Because we don't want to do "pSplitterDlg->"
// in front of every variable and member function that we use... so we
// cheat and immediately call a member function... TrustedWorkerThread.

UINT WorkerThread ( LPVOID lpParam)
{
    CComcapDlg *pCComcapDlg = (CComcapDlg *)lpParam;
    return (pCComcapDlg->TrustedWorkerThread ());
}

/////////////////////////////////////////////////////////////////////////////
// DoOutputLine - spit something to the output listbox

void CComcapDlg::DoOutputLine ( CString Str)
{
    // call the objects method which of course is most likely a SendMessage of
    // LB_ADDSTRING
    m_Output.AddString ( Str );

}

/////////////////////////////////////////////////////////////////////////////
// TrustedWorkerThread - the main test thread.

UINT CComcapDlg::TrustedWorkerThread (void)
{
    BY_HANDLE_FILE_INFORMATION InputFileInfo;
    DWORD       nSize;
    CAPTUREFILE CapFile;
    SYSTEMTIME  SysTime;
    DWORD       FileOffset;
    LPDWORD     FrameTable;
    DWORD       FrameTableSize;
    DWORD       CurrentPos;
    LPFRAME     lpFrame;
    DWORD       nFrames = 0;
    CString     Temp;



    DoOutputLine("Trusted Worker Thread Started.");
    
    DoOutputLine("Mapping Files....");

    hInputFile = CreateFile (   (LPCTSTR)m_InputFilename,
                                GENERIC_READ,
                                0,
                                NULL,
                                OPEN_EXISTING,
                                FILE_ATTRIBUTE_NORMAL,
                                NULL ); // no template

    if (hInputFile==INVALID_HANDLE_VALUE)
    {
        GetDlgItem ( IDC_INPUTFILENAME)->EnableWindow (TRUE);
        GetDlgItem ( IDC_OUTPUTFILENAME)->EnableWindow (TRUE);
        m_MBOK.EnableWindow (TRUE);

        Temp.Format ("CreateFile on input file (%s) failed with error 0x%X", (LPCTSTR)m_InputFilename, GetLastError() );
        MessageBox (Temp);

        GetDlgItem ( IDC_INPUTFILENAME)->SetFocus();
        return 0;
    }

    // we need to guess the size of the mem mapped file...
    if ( GetFileInformationByHandle(hInputFile, &InputFileInfo)==FALSE)
    {
        GetDlgItem ( IDC_INPUTFILENAME)->EnableWindow (TRUE);
        GetDlgItem ( IDC_OUTPUTFILENAME)->EnableWindow (TRUE);
        m_MBOK.EnableWindow (TRUE);

        Temp.Format ("GetFileInformationByHandle on input file (%s) failed with error 0x%X", (LPCTSTR)m_InputFilename, GetLastError() );
        MessageBox (Temp);

        GetDlgItem ( IDC_INPUTFILENAME)->SetFocus();
        CloseHandle ( hInputFile );
        return 0;
    }
    nInFileSize = InputFileInfo.nFileSizeLow; // bugbug handle 64bit...

    hMapInputFile = NULL;
    hMapInputFile = CreateFileMapping(   hInputFile,
                                    NULL,  // no security
                                    PAGE_READONLY,
                                    InputFileInfo.nFileSizeHigh,
                                    InputFileInfo.nFileSizeLow,
                                    NULL );
    if (hMapInputFile == NULL)
    {
        GetDlgItem ( IDC_INPUTFILENAME)->EnableWindow (TRUE);
        GetDlgItem ( IDC_OUTPUTFILENAME)->EnableWindow (TRUE);
        m_MBOK.EnableWindow (TRUE);

        Temp.Format ("CreateFileMapping on Input file (%s) failed with error 0x%X", (LPCTSTR)m_InputFilename, GetLastError() );
        MessageBox (Temp);

        GetDlgItem ( IDC_INPUTFILENAME)->SetFocus();
        CloseHandle ( hInputFile );
        return 0;
    }

    lpInFile = (LPBYTE)MapViewOfFile(hMapInputFile, FILE_MAP_READ, 0, 0, InputFileInfo.nFileSizeLow);
    if (lpInFile == NULL)
    {
        GetDlgItem ( IDC_INPUTFILENAME)->EnableWindow (TRUE);
        GetDlgItem ( IDC_OUTPUTFILENAME)->EnableWindow (TRUE);
        m_MBOK.EnableWindow (TRUE);

        Temp.Format ("MapViewOfFile on Input file (%s) failed with error 0x%X", (LPCTSTR)m_InputFilename, GetLastError() );
        MessageBox (Temp);

        GetDlgItem ( IDC_INPUTFILENAME)->SetFocus();
        CloseHandle ( hMapInputFile );
        CloseHandle ( hInputFile );
        return 0;
    }





    // create the skeleton file and then start parsing the serial input...
    
    hOutputFile = CreateFile (  (LPCTSTR)m_OutputFilename,
                                GENERIC_READ | GENERIC_WRITE,
                                0,  // no share
                                NULL, // no security
                                CREATE_ALWAYS,
                                FILE_ATTRIBUTE_NORMAL,
                                NULL ); // no template

    if (hOutputFile==INVALID_HANDLE_VALUE)
    {
        GetDlgItem ( IDC_INPUTFILENAME)->EnableWindow (TRUE);
        GetDlgItem ( IDC_OUTPUTFILENAME)->EnableWindow (TRUE);
        m_MBOK.EnableWindow (TRUE);

        Temp.Format ("CreateFile on output file (%s) failed with error 0x%X", (LPCTSTR)m_OutputFilename, GetLastError() );
        MessageBox (Temp);

        GetDlgItem ( IDC_OUTPUTFILENAME)->SetFocus();
        CloseHandle ( hMapInputFile );
        CloseHandle ( hInputFile );
        return 0;
    }


    nSize = InputFileInfo.nFileSizeLow * 2;
    if ( ( (nSize / 2) != InputFileInfo.nFileSizeLow ) ||
         ( InputFileInfo.nFileSizeHigh) )
    {
        DebugBreak();  // BUGBUG
    }

    hMapOutputFile = NULL;
    hMapOutputFile = CreateFileMapping(   hOutputFile,
                                    NULL,  // no security
                                    PAGE_READWRITE,
                                    0,      // high 32 bits
                                    nSize,  // how big is the input file??
                                    NULL );
    if (hMapOutputFile == NULL)
    {
        GetDlgItem ( IDC_INPUTFILENAME)->EnableWindow (TRUE);
        GetDlgItem ( IDC_OUTPUTFILENAME)->EnableWindow (TRUE);
        m_MBOK.EnableWindow (TRUE);

        Temp.Format ("CreateFileMapping on output file (%s) failed with error 0x%X", (LPCTSTR)m_OutputFilename, GetLastError() );
        MessageBox (Temp);

        GetDlgItem ( IDC_OUTPUTFILENAME)->SetFocus();
        CloseHandle ( hMapInputFile );
        CloseHandle ( hOutputFile );
        CloseHandle ( hInputFile );
        return 0;
    }

    lpOutFile = (LPBYTE)MapViewOfFile(hMapOutputFile, FILE_MAP_WRITE, 0, 0, nSize);
    if (lpOutFile == NULL)
    {
        GetDlgItem ( IDC_INPUTFILENAME)->EnableWindow (TRUE);
        GetDlgItem ( IDC_OUTPUTFILENAME)->EnableWindow (TRUE);
        m_MBOK.EnableWindow (TRUE);

        Temp.Format ("MapViewOfFile on output file (%s) failed with error 0x%X", (LPCTSTR)m_OutputFilename, GetLastError() );
        MessageBox (Temp);

        GetDlgItem ( IDC_OUTPUTFILENAME)->SetFocus();
        CloseHandle ( hMapInputFile );
        CloseHandle ( hMapOutputFile );
        CloseHandle ( hOutputFile );
        CloseHandle ( hInputFile );
        return 0;
    }

    // oh boy, we have a file pointer... 

    CapFile.Header.Signature   = CAPTUREFILE_SIGNATURE;                    
    CapFile.Header.BCDVerMajor = 1;
    CapFile.Header.BCDVerMinor = 0;
    CapFile.Header.MacType     = (WORD)MAC_TYPE_ETHERNET; 
                        
    GetSystemTime(&SysTime);
    memcpy( &CapFile.Header.TimeStamp,                                      
            &SysTime,
            sizeof(SYSTEMTIME));                                                

    memcpy ( lpOutFile, &CapFile,CAPTUREFILE_SIZE);
                                                                           
    FileOffset = CAPTUREFILE_SIZE;                                             

    // hmmm... we have a problem... we need to make a frame table, but 
    // we DONT know how big it is...  make one big enough for 20 bytes
    // per frame on the input file size for now...

    FrameTableSize = FRAMETABLE_SIZE + (nSize/20 + 2) *  sizeof(LPFRAMEDESC);
    if ( (FrameTable = (LPDWORD)GlobalAlloc (GMEM_FIXED, FrameTableSize)) == NULL )
    {
        GetDlgItem ( IDC_INPUTFILENAME)->EnableWindow (TRUE);
        GetDlgItem ( IDC_OUTPUTFILENAME)->EnableWindow (TRUE);
        m_MBOK.EnableWindow (TRUE);

        MessageBox ("Out of memory on FrameTable");

        GetDlgItem ( IDC_OUTPUTFILENAME)->SetFocus();
        return 0;
    }


    // bleh.. we write frames in "cache blocks"... a throwback from ndis20 days..
    // Track this with CurrentPos pointer...
    CurrentPos = 0;    

    // write each frame into the mapped file, storing the offset 
    // of each frame in the frame table...

    DoOutputLine("Transfering frames....");

    while ( 1 )
    {
        ExtractFrame ( (LPVOID *)&lpFrame );
        if ( lpFrame == NULL )
            break;
        else
        {
            DWORD nFrameSize = sizeof(FRAME)+ lpFrame->nBytesAvail;

            //if ((CurrentPos + nFrameSize )> CACHE_BLOCK_SIZE )

            FrameTable[nFrames++]=FileOffset;
            memcpy(lpOutFile + FileOffset, lpFrame, nFrameSize  );
            CurrentPos += nFrameSize;
            FileOffset += nFrameSize;
        }
    }

    FrameTableSize = nFrames * sizeof(LPFRAMEDESC);

    // update the header for the frame table location.
    CapFile.Header.FrameTableOffset = FileOffset;
    CapFile.Header.FrameTableLength = FrameTableSize;

    // write the frame table.
    memcpy(lpOutFile + FileOffset, FrameTable, FrameTableSize);

    FileOffset += FrameTableSize;

    Temp.Format("Serial to Cap converted file, input file was %s",m_InputFilename);

    CapFile.Header.CommentDataOffset = FileOffset;
    CapFile.Header.CommentDataLength = strlen((LPCTSTR)Temp)+1;
    memcpy(lpOutFile+FileOffset, (LPCTSTR)Temp, strlen((LPCTSTR)Temp)+1);

    // write the header file...
    memcpy (lpOutFile, &CapFile, CAPTUREFILE_SIZE);


    DoOutputLine("Worker Thread Terminating.");

    CloseHandle ( hMapInputFile );
    CloseHandle ( hMapOutputFile );
    CloseHandle ( hOutputFile );
    CloseHandle ( hInputFile );

    Sleep (2000);
    DoOutputLine("Hey Koti.. got any kids yet??");
    Sleep (3000);
    
    EndDialog(0);
    return 0;
}


BYTE FromTag[]  ={0x00,0x00,0x11,0x11,0x11,0x11};
BYTE ToTag[]    ={0x00,0x00,0x22,0x22,0x22,0x22};
BYTE HeaderTag[]={0x00,0x34,0xE9,0xE9,0x03};

void CComcapDlg::ExtractFrame ( LPVOID * lpRet )
{
    static DWORD Count = 0;
    static LPBYTE lpCurrent = lpInFile;
    static BOOL fFirstTime = TRUE;
    static int nItems=0;
    BOOL fFrom = TRUE;
    int i;
    WORD nSize=0;
    
    // our data looks like this:
    // 0000: 0d^2b^2b^2b^00^41^54^48^0d^0d 0a 4f 4b 0d 0a 41^  [.+++.ATH...OK..A]    
    // 0010: 54^26^66^0d^0d 0a 4f 4b 0d 0a 41^54^41 26^54 26   [T&f...OK..ATA&T&]    
    // 0020: 66^26^66 64^26 32^64 78^32 34^78 53^34 30^53 30   [f&fd&2dx24xS40S0]    
    // 0030: 3d^30^3d 45^30 30^45 26^30 6d^26 30^6d 0d^30 0d   [=0=E00E&0m&0m.0.]    
    // 0040: 0d 0a 4f 4b 0d 0a 41^54^53^30^3d^31^0d^0d 0a 4f   [..OK..ATS0=1...O]    
    // 0050: 4b 0d 0a 0d 0a 52 49 4e 47 0d 0a 0d 0a 43 4f 4e   [K....RING....CON]    

    // if it has a "^" after the number, it is FROM, else it is TO...

    // lpInFile is the pointer directly into the input file (mem mapped)...

    if (fFirstTime)
    {
        lpCurrent+=0x5a;
        fFirstTime=FALSE;
    }

    if ( (DWORD)((lpCurrent+20) - lpInFile) > nInFileSize ) // at least 7 chars big
    {
        *lpRet = NULL;
        return;
    }
    
    
    // OK, pull them off 3 at a time.  Look ahead.  If we 
    // setup a fake frame from the serial data.

    i=0;
    nSize=0;

    lpFrame->TimeStamp = Count*10;

    if ( *(lpCurrent+2)=='^')
        fFrom=TRUE;
    else
        fFrom=FALSE;

    memcpy ( &lpFrame->MacFrame[i], fFrom?FromTag:ToTag, sizeof(FromTag));
    i+=sizeof(FromTag);
    memcpy ( &lpFrame->MacFrame[i], fFrom?ToTag:FromTag, sizeof(FromTag));
    i+=sizeof(FromTag);
    memcpy ( &lpFrame->MacFrame[i], HeaderTag, sizeof(HeaderTag));
    i+=sizeof(HeaderTag);
    // note that we have to go back and FIX the ethernet frame length...

    while (1)
    {
        BYTE Hi; 
        BYTE Low;

        Hi = (*lpCurrent>='a')?(*lpCurrent-'a'+10)*0x10:(*lpCurrent-'0')*0x10;
        lpCurrent++;
        Low = (*lpCurrent>='a')?(*lpCurrent-'a'+10):(*lpCurrent-'0');
        lpCurrent+=2; // skip the space or '^'
        
        if ( (DWORD)(lpCurrent - lpInFile) > nInFileSize )
            break;

        lpFrame->MacFrame[i++]=Hi+Low;
        nItems++;
        nSize++;

        // are we at the end of the line?
        if ( nItems == 16 )
        {
            nItems=0;
            // move to the beginning of the next line.
            while (*lpCurrent != 0x0a)
            {
                lpCurrent++;
                if ( (DWORD)(lpCurrent - lpInFile) > nInFileSize )
                    break;
            }

            if ( *(lpCurrent+1)==0x0d)
                lpCurrent+=10;  // skip the line feed and the header of the next line.
            else
                lpCurrent+=8;  // skip the line feed and the header of the next line.
            if ( (DWORD)(lpCurrent - lpInFile) > nInFileSize )
                break;
        }

        // does the next byte represent a state change??
        if ( (fFrom &&  (*(lpCurrent+2)==' ')) ||
             (!fFrom && (*(lpCurrent+2)=='^')) )
        {
            break;
        }
    }

    // set the size for the ethernet header...

    nSize += sizeof(FromTag) + sizeof(ToTag) + sizeof(HeaderTag);

    lpFrame->MacFrame[13] = LOBYTE(nSize);
    lpFrame->MacFrame[12] = HIBYTE(nSize);
    lpFrame->nBytesAvail = nSize;
    lpFrame->FrameLength = nSize;

    *lpRet = lpFrame;
}
